import re
from random import randint
from copy import copy

def pick_another(word, words):
    while len(words) > 1:
        i = randint(0, len(words) - 1)
        if (words[i] != word):
            return words[i]

def rotate_words(s, words):
    result = copy(s)
    indices_pairs = [(m.start(0), m.end(0)) for m in re.finditer('|'.join(words), s)]
    for indices_pair in indices_pairs:
        i, j = indices_pair
        result = result[:i] + pick_another(result[i:j], words) + result[j:]
    return result